const express = require("express");
const router = express.Router();
const authorize = require("../../../../middlewares/authorize-sapps");
const ItemGroupService = require("./itemGroup.service");

router.post("/create", authorize(), create);
router.get("/", authorize(), getAll);
router.get("/filter", authorize(), filter);
router.get("/option", authorize(), option);
router.get("/count", authorize(), count);
router.put("/:id", authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete("/:id", authorize(), _delete);

module.exports = router;

function create(req, res, next) {
  ItemGroupService
    .create(req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function getAll(req, res, next) {
  ItemGroupService
    .getAll()
    .then((result) => res.json(result))
    .catch(next);
}

function filter(req, res, next) {
  ItemGroupService
    .filter(req.query)
    .then((result) => res.json(result))
    .catch(next);
}

function option(req, res, next) {
  ItemGroupService
    .option()
    .then((result) => res.json(result))
    .catch(next);
}

function count(req, res, next) {
  ItemGroupService
    .count()
    .then((result) => res.json(result))
    .catch(next);
}

function update(req, res, next) {
  ItemGroupService
    .update(req.params.id, req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function enabled(req, res, next) {
  ItemGroupService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function _delete(req, res, next) {
  ItemGroupService
    .delete(req.params.id)
    .then((result) => res.json(result))
    .catch(next);
}
